//Propagació ona transversal by Rosa
int xspacing;   // Número de punts
int w;          // Amplada de l'ona 

float theta ;  //Comença l'angle a 0
float amplitude = 75.0;  // Alçada ona
float period = 300;  // Pixels a partir dels que la ona es repeteix
float dx;  // Valor per incrementar x, funció del període i xspacing
float[] yvalues;  // Array per emmagatzemar els valors d'alçada de l'ona

void setup() {
  size(600, 400); //mida requerida de la pantalla de mostra
  xspacing = width/30; // número de punts, 30, en l'eix x
  period = width/2; //amplitud de l'ona a la meitat de l'amplada
  w = width+20;  // Amplada de l'ona 
  dx = (TWO_PI / period) * xspacing;
  yvalues = new float[w/xspacing];
}

void draw() {
  background(255, 255, 255);
  calcWave();
  renderWave();
}

void calcWave() {
  // Increment de theta, ajustar període a 2s
  theta += 1/(60/PI);

  // per cada valor x, calcula un valor y amb una funció sinus 
  float x = theta;
  for (int i = 0; i < yvalues.length; i++) {
    yvalues[i] = sin(x)*amplitude;
    x+=dx;
  }
}

void renderWave() {
  noStroke();
  fill(102, 45, 145);
  // dibuixar l'ona amb un cercle en cada punt, localització
  for (int x = 0; x < yvalues.length; x++) {
    ellipse(x*xspacing, height/2+yvalues[x], 10, 10);
  }
}

